' Bezeichnung:	STK2BST_v1-1.vbs
' Version:		  v1-1
' Erstellt:		  10.07.2005; GM
' l.nderung:	  22.07.2005; GM: v1-1, Script Arbeitet wie vorgesehen, Code bereinigt
'								Offene Punkte lt.Dateiende
'
' Beschreibung: STK-List to BST-List Converter
'				Aufgabe des Skriptes:
'				- STK-Liste, in welcher fr jeden Artikel das entspr. ORTS-Kennzeichen
'				  vorhanden ist, in eine BST-Liste umwandeln.(Gleiche Artikel werden
'				  Ortsbezogen aufsumiert)
' Verwendung:	
'
' (c) 2005, Gerald Mayer (www.smartineer.com)
'________________________________________________________________________
' Allgemeine Hinweise:
' 	"g" vor Variablennamen = globale Variable
' 	"p" vor Variablennamen = private Variable	
'
' ungarische Notation: (Prfixe fr Variablen)
'	c		char, WCHAR oder TCHAR
'	b, f	BOOL (int); das f steht fr "flag"
'	s		String
'	fn		Funktion
'	i		int
'________________________________________________________________________


option explicit

'Allgemein
	DIM FSO, WshShell
'bergabe der Argumente
	DIM gArrArgs(), gsArgs
	DIM giArgs
'Variablen fr: Prfen und erstellen der Zieldatei
	DIM gZiel, gZielFile, gZielPfad
'Fehlermeldungen
	DIM gsErr01_Prompt, gsErr01_Title				' Falsche Anzahl von Argumenten
	DIM gsErr02_Prompt, gsErr02_Title				' Datei konnte nicht geffnet werden
	DIM gsErr03_Prompt, gsErr03_Title				' Das bergebene Argument ist keine Datei
'Variablen fr: Erstellung der BST
	DIM gsFile01, gsZeile1, gsZeile2
	DIM gsSuchOrt, gsSuchBestNr, gsQuellBez1, gsQuellBez2
	DIM gArrArtikel()
	DIM giBelegt			' Variable die den Wert der unterschiedlichen Best.Nr an nimmt
'Variablen fr fnGetZeilen
	DIM giAnzahlZeilen
'Variablen fr das Fehlerprotokoll
	DIM gsLog
	
	Set WshShell = WScript.CreateObject("WScript.Shell")
	Set FSO = createObject("Scripting.FileSystemObject")
	Set gsArgs = WScript.Arguments

'Fehlermeldungen
	gsErr01_Title = "Error # 1"
	gsErr01_Prompt = "Es wurde eine falsche Anzahl von Argumenten bergeben! "& "(" & gsArgs.Count & ")"
	gsErr02_Title = "Error # 2"
	gsErr02_Prompt = "Fehler beim ffnen der Datei: " & vbCr
	gsErr03_Title = "Error # 3"
	gsErr03_Prompt = "Das bergebene Argument ist keine Datei: " & vbCr

	
	
'Programmparameter
	giArgs = 1						'Anzahl der Argumente die an VBS bergeben werden mssen 
	gZielFile = "Bestellliste.txt"	'Name der Zieldatei
	giBelegt = 0
	gsLog = "STK2BST.log"			'Name der Protokolldatei
'________________________________________________________________________


funcMain()


function funcMain()
	DIM psX

  fnGetArgs()
	subCheckArgs()				'berprfung ob Infos bergeben wurden!
  fnGetZielpfad()	
	fnCreateLog()					'Erstellt das Logbuch-File
	fnCreateBST()					'Erstellt die Zieldatei der Gesamtbestellliste
	fnGetZeilen()					'Ermittelt die Anzahl der Zeilen der Quelldatei
                        'fr das dynamische Array "gArrArtikel"
	fnStartBST()					'startet die Erstellung der Bestellliste
	fnAusgabe()						'schreibt den Inhalt von "gArrArtikel" nach: Ziel
	fnOpenBST()						'ffnet zum Schluss die Gesamtbestellliste

	psX = fnWriteLog("		Programm ordnungsgem beendet", "")
end function


' Erstellt ein dynamisches Array mit einer Anzahl an Feldern die der 
' Anzahl der bergebenen Argumenten entspricht. Dieses Array wird im 
' Programmverlauf weiterverwendet.
function fnGetArgs()
	DIM psInfo, piX
	piX = 0

	Redim gArrArgs(gsArgs.Count)			' Fllt das Array "gArrArgs" mit den
											' bergebenen Argumenten.
	for each psInfo in gsArgs				' nicht notwendig,da nur 1 Arg. bergeben werden darf
		gArrArgs(piX) = psInfo
		piX = piX + 1
	next
end function



' berprft die Argumente die per drag&drop oder "send to..." an das
' Skript bergeben wurden.
' Fr dieses Skript darf nur 1 Argument bergeben werden (Gesamt-STK)
' Die Anzahl der erlaubten Args. (giArgs) wird in den Programmparametern
' definiert.
' Diese Funktion prft auch ob das bergebene Argument eine Datei ist und
' beendet das Script falls ein Verzeichnis bergeben wurde.  
sub subCheckArgs()
	if gsArgs.Count <> giArgs then                                                           
		MsgBox gsErr01_Prompt,64, gsErr01_Title
		Wscript.Quit
	elseif fso.FileExists(gArrArgs(0)) = false then
		MsgBox gsErr03_Prompt & "(" & gArrArgs(0) & ")",48, gsErr03_Title
		Wscript.Quit
	end if
end sub


' Hier wird der Ausgabepfad der Zieldatei aus dem Pfad der
' Quelldatei ermittelt.
' Falls die Zieldatei nicht existiert wird sie angelegt.
function fnGetZielpfad()
	Set gZielPfad = FSO.GetFile(gArrArgs(0))
	gZielPfad = gZielPfad.ParentFolder
end function



function fnCreateBST
	DIM psX, psBSTErstellt
	psBSTErstellt = "		Gesamtstckliste erstellt: "
	gZiel = gZielPfad & "\" & gZielFile
	fso.CreateTextFile(gZiel)				'Datei wird angelegt, auch wenn vorhanden 
	psX = fnWriteLog(psBSTErstellt, gZiel)
end function



function fnCreateLog
	DIM psX, psLogErstellt1
	psLogErstellt1 = "		Protokoll erstellt: "
	gsLog = gZielPfad & "\" & gsLog
	fso.CreateTextFile(gsLog)
	psX = fnWriteLog(psLogErstellt1 & """" & gsLog & """","")
end function



function fnWriteLog(Arg1, Arg2)
	DIM psX
	set psX = fso.OpenTextFile (gsLog,8)
	psX.writeLine(Date & " " & Time & " " & Arg1 & Arg2)	
	psX.Close
end Function



' Ermittelt die Anzahl der Zeilen in der Quelldatei
' und deklariert ein dynamisches Array das die Artikeldaten enthalten wird.
function fnGetZeilen()
	DIM piN, piX, pSTK
	piX = 0
	set pSTK = FSO.OpenTextFile(gArrArgs(0), 1)
	
	do until pSTK.AtEndOfStream
		piN = pSTK.ReadLine
		piX = piX + 1
	loop
	giAnzahlZeilen = piX
	pSTK.close
	
	REDIM gArrArtikel(giAnzahlZeilen,5)
end function




function fnStartBST()
	set gsFile01 = FSO.OpenTextFile(gArrArgs(0), 1)
	do until gsFile01.AtEndOfStream			' liest Zeilen aus der Quelle
		gsZeile1 = gsFile01.ReadLine
		fnCutZeile(gsZeile1)				' ermittelt die Einzelnen Datenfelder
		fnCheckArtikelWiederholung
	loop
	gsFile01.close
end function




function fnCutZeile(psZeile)
DIM psGetOrt, psGetBestNr, psZeileShort, piPosition, psGetBez1, psGetBez2

'	GetOrt
	piPosition = instr(psZeile, ";")
		if piPosition>0 then psGetOrt = mid(psZeile, 1, piPosition-1)

'	GetBezeichnung 1
	piPosition = instr(psZeile, ";")
		if piPosition>0 then psZeileShort = mid(psZeile, piPosition+1, 256)
		piPosition = instr(psZeileShort, ";")
			if piPosition>0 then psGetBez1 = mid(psZeileShort, 1, piPosition-1)
	
'	GetBezeichnung 2	
	piPosition = instr(psZeileShort, ";")
		if piPosition>0 then psZeileShort = mid(psZeileShort, piPosition+1, 256)
		piPosition = instr(psZeileShort, ";")
			if piPosition>0 then psGetBez2 = mid(psZeileShort, 1, piPosition-1)

'	GetBestellnummer			
	piPosition = instr(psZeileShort, ";")
		if piPosition>0 then psZeileShort = mid(psZeileShort, piPosition+1, 256)
		piPosition = instr(psZeileShort, ";")
			if piPosition>0 then psGetBestNr = mid(psZeileShort, 1, piPosition-1)


	gsSuchOrt = psGetOrt
	gsQuellBez1 = psGetBez1
	gsQuellBez2 = psGetBez2
	gsSuchBestNr = psGetBestNr
end function




' Diese Funktion Prft ob eine Bestellnummer und ein Ortskennzeichen schon mal
' vorgekommen sind. Ist dies der Fall, wird die Gesamtmenge um 1 erhht und die
' Funktion an dieser Stelle verlassen.
' Gibt es keine Wiederholung bei Ortskennzeichen und/oder Best.Nr. so wird am Ende
' der Funktion eine neue Funktion aufgerufen welche den neuen Artikel in das Array
' einfgt. 
function fnCheckArtikelWiederholung
	DIM piA, piB, pbC
	piA = giBelegt
	piB = 0
	pbC = giBelegt

 	do
		if gArrArtikel(piB,1) = gsSuchBestNr then			' Wenn Best.Nr. gefunden dann:
			if gArrArtikel(piB,0) = gsSuchOrt then			' Wenn Ort gefunden dann:
				gArrArtikel(piB,2) = gArrArtikel(piB,2) + 1	' Menge = Menge + 1
				exit function
			end if
		end if
		piB = piB + 1
	loop while piB <= piA		' wiederhole solange "Zhler" <= "belegte Felder" ist

	pbC = fnAddArtikel(gsSuchOrt,gsSuchBestNr)

end Function




function fnAddArtikel(psOrt, psArtikel)
	gArrArtikel(giBelegt,0) = gsSuchOrt
	gArrArtikel(giBelegt,3) = gsQuellBez1
	gArrArtikel(giBelegt,4) = gsQuellBez2
	gArrArtikel(giBelegt,1) = gsSuchBestNr
	gArrArtikel(giBelegt,2) = gArrArtikel(giBelegt,2) + 1
	giBelegt = giBelegt + 1
end function




' schreibt die Inhalte des mit Artikeldaten gefllten Arrays "gArrArtikel"
' in die Ausgabedatei "gZiel". Die vorhandenen Daten werden dabei berschrieben.
' (OpenTextFile: ForWriting=2, ForAppending=8)
function fnAusgabe
	DIM psZiel, x, psX
	Set psZiel = FSO.OpenTextFile(gZiel, 2)
	for x = 0 to giBelegt-1
		psZiel.writeLine(gArrArtikel(x,0) & ";" _
					   & gArrArtikel(x,3) & ";" _
					   & gArrArtikel(x,4) & ";" _
					   & gArrArtikel(x,1) & ";" _
					   & """" & gArrArtikel(x,2) & """")
	next
	psZiel.close
	psX = fnWriteLog("		Bestelldaten nach " & """" & gZiel & """" & " geschrieben.", "")
end function




' ffnet die neu erstellte Bestellliste zur Kontrolle durch den Benutzer
function fnOpenBST
	on Error Resume next							' Schaltet die Fehlerberwachung
													' nur in dieser Funktion ab.
													
	WshShell.run gZiel								' NTFS: Zugriffsrechte beachten!
	if Err.Number <> 0 then
		Err.Raise 2,gZiel,gsErr02_Prompt			' generiert eine Fehlermeldung
		Msgbox Err.Description & "(" & Err.Source & ")", 48, "Error # " & Err.Number 
		Err.Clear   								' Clear the error.
	end if
End Function



'##################################### Ende #####################################

' Restarbeiten:
'	- Programm soll prfen ob und welche ausgemusterte Artikel verwendet werden
'	- Abfrage am Ende der Datei ob Feldweise Bestelllisten erstellt werden sollen
'	- eigene Funktion fr die Fehlerbehandlung erstellen ?
'	- Protokollierung fertigstellen (Details mssen noch ausgearbeitet werden)

